C     Programme RdaCca
C
C     Analyse canonique des correspondances (ACC)
C     calculee selon les equations de la section 11.2.1 de Numerical ecology.
C        Matrice Y (nxp)
C        Matrice X (nxm)
C     Le fichier d'entree contient une en-tete (n,p,m) 
C     suivie des fichiers Y et X accoles.
C
C     Methodes de calcul: Householder ou decomposition en valeurs singulieres.
C     
C                Pierre Legendre, novembre 1997
C
C Ajouter les caracteristiques suivantes au programme:
C    Sauver de la memoire (Equivalence)
C    Ajouter les numeros d'equations de Numerical Ecology
C    Ameliorer la lecture des donnees: format Canoco, etc.
C    Biplot scores; centroids
C    ACP par SVD directe de la matrice Y: equation 2.31
C ----------------------------------------------------------------------
C23456789012345678901234567890123456789012345678901234567890123456789012
C If you change this parameter, make sure you also change it in subroutine GAUSSJ
      Parameter (nmax=100)
      Integer p,nombre(nmax)
      Real*8 Y(nmax,nmax),  Q(nmax,nmax),Qbar(nmax,nmax),
     +       Yres(nmax,nmax),X(nmax,nmax),Xprime(nmax,nmax),
     +       Inverse(nmax,nmax),Yhat(nmax,nmax)
      Real*8 Fip(nmax),Dip(nmax),Dipsq(nmax),Dipmsq(nmax),
     +       Dpj(nmax),Dpjsq(nmax),Dpjmsq(nmax),Ftot,totinert
      Real*8 sx(nmax),sx2(nmax),xbar(nmax),sdev(nmax)
      Real*8 Lambda(nmax),SingVal(nmax),U(nmax,nmax),Uhat(nmax,nmax),
     +       UL(nmax,nmax),E(nmax)
      Real*8 V(nmax,nmax),Vhat(nmax,nmax),F(nmax,nmax)
      Real*8 Z(nmax,nmax),vect(nmax),temp
      Equivalence (V,F), (Xprime,V), (Inverse,Vhat)
      Character tt*10
      Character*79 nom
C Choix de la langue de dialogue / Dialogue language
    2 write(*,*) 'Langue / Language'
      write(*,*) '  (1) Francais'
      write(*,*) '  (2) English'
      read(*,*) langue
      if((langue.lt.1).or.(langue.gt.2)) goto 2
C Ecrire les resultats sur un fichier? / Write results to a file?
    4 if(langue.eq.1) write(*,115) 
      if(langue.eq.2) write(*,215)
      read(*,*) ichoix4
      write(*,*)
      if((ichoix4.lt.1).or.(ichoix4.gt.2)) goto 4
      if(ichoix4.eq.1) then
         LUT=6
         else
         LUT=7
         if(langue.eq.1) then
            write(*,*) 'Nom du fichier de sortie?'
            read(*,'(A)') nom
            open(LUT,File=nom)
            else
            write(*,*) 'Name of the output file?'
            read(*,'(A)') nom
            open(LUT,File=nom)
            endif
         inquire(unit=LUT,name=nom)
         if(langue.eq.1) write(*,*) 'Fichier de sortie: ',nom
         if(langue.eq.2) write(*,*) 'Output file: ',nom
         endif
C
      if(langue.eq.1) write(LUT,*) 'Ordination lineaire et analyse ',
     +'canonique'
      if(langue.eq.2) write(LUT,*) 'Linear ordination and canonical ',
     +'analysis'
      write(LUT,*) 'Pierre Legendre, Universite de Montreal'
      write(*,*)
C Lecture des donnees / Read data file
      call ReadData(n,p,m,nmax,Y,X,langue,LUT)
C *** Activate the following lines to test the eigenanalysis on the transposed
C matrix, in subroutine Eigen. If the procedure works correctly, calculations on the
C original and transposed matrices should give the same results for a square matrix.
      ichoix5=1
C      if(n.eq.p) then
C         write(*,*)
C         if(langue.eq.1) then
C            write(*,*) '(1) Calcul sur la matrice originale'
C            write(*,*) '(2) Calcul sur la matrice transposee'
C            else
C            write(*,*) '(1) Calculation on the original matrix'
C            write(*,*) '(2) Calculation on the transposed matrix'
C            endif
C         read(*,*) ichoix5
C         endif
C ***
      if(LUT.eq.7) write(LUT,*)
C Preliminaires / Preliminaries
C     Methode d'ordination / Ordination method
    6 if(langue.eq.1) write(*,116) 
      if(langue.eq.2) write(*,216)
      read(*,*) irdacca
      if((irdacca.lt.1).or.(irdacca.gt.2)) goto 6
      if(LUT.eq.6) write(LUT,*)
C     Combien de valeurs propres? / How many eigenvalues?
      if(irdacca.eq.1) nvalc=min(p,m,(n-1))
      if(irdacca.eq.2) nvalc=min((p-1),m,(n-1))
      if(langue.eq.1) write(LUT,110) nvalc
      if(langue.eq.2) write(LUT,210) nvalc
      if(irdacca.eq.1) nvalpr=min(p,(n-1))
      if(irdacca.eq.2) nvalpr=min((p-1),(n-1))
      if(langue.eq.1) write(LUT,111) nvalpr
      if(langue.eq.2) write(LUT,211) nvalpr
      if(LUT.eq.7) write(LUT,*)
C     Methode d'analyse d'inertie: Householder ou SVD ?
C     Eigenanalysis method: Householder or SVD ?
    8 if(langue.eq.1) write(*,112) 
      if(langue.eq.2) write(*,212)
      read(*,*) ichoix1
      if((ichoix1.lt.1).or.(ichoix1.gt.2)) goto 8
C     Analyse canonique et/ou analyse des residus ?
C     Canonical analysis and/or analysis of residuals ?
      if(m.gt.0) then
   10    if(langue.eq.1) write(*,113) 
         if(langue.eq.2) write(*,213)
         read(*,*) ichoix2
         if((ichoix2.lt.1).or.(ichoix2.gt.3)) goto 10
         endif
C     Impression de resultats intermediaires ?
C     Print intermediate result tables ?
   12 if(langue.eq.1) write(*,109) 
      if(langue.eq.2) write(*,209)
      read(*,*) iprint
      if((iprint.lt.0).or.(iprint.gt.4)) goto 12
C     Cadrage des lignes et des colonnes
C     Scaling of rows and columns
   14 if(irdacca.eq.1) then
         if(langue.eq.1) write(*,117) 
         if(langue.eq.2) write(*,217)
         else
         if(langue.eq.1) write(*,114) 
         if(langue.eq.2) write(*,214)
         endif
      read(*,*) ichoix3
      if((ichoix3.lt.1).or.(ichoix3.gt.2)) goto 14
      if(LUT.eq.6) write(LUT,*)
C     Demarrage de l'horloge / Start the clock
C     call time(tt)
      debut=secnds(0.0)
C Transformation des matrices Y et X / Transform matrices Y and X
      if(irdacca.eq.1) then
         call TransRDA(n,p,m,nmax,Y,X,totinert,
     +                 sx,sx2,xbar,sdev,iprint,langue,LUT)
         if(langue.eq.1) write(LUT,102) totinert,totinert/dfloat(n-1)
         if(langue.eq.2) write(LUT,202) totinert,totinert/dfloat(n-1)
         totinert=totinert/dfloat(n-1)
         do 18 i=1,n
         Dip(i)=1.0
         Dipsq(i)=1.0
         do 18 j=1,p
   18    Qbar(i,j)=Y(i,j)
         else
         call TransCCA(n,p,m,nmax,Y,Qbar,X,Fip,Dip,Dpj,Ftot,totinert,
     +                 sx,sx2,xbar,sdev,iprint,langue,LUT)
C        Y contient maintenant les freq. relatives / Y now contains relative freq.
         do 20 i=1,n
         Dipsq(i)=dsqrt(Dip(i))
   20    Dipmsq(i)=1.0/Dipsq(i)
         do 22 j=1,p
         Dpjsq(j)=dsqrt(Dpj(j))
   22    Dpjmsq(j)=1.0/Dpjsq(j)
         if(langue.eq.1) write(LUT,101) totinert
         if(langue.eq.2) write(LUT,201) totinert
         endif
C ACP ou AFC: sauter l'etape de regression / PCA or CA: skip the regression step
      if(m.eq.0) then
         do 24 i=1,n
         do 24 j=1,p
   24    Yres(i,j)=Qbar(i,j)
         goto 42
         endif
C Regression pour l'analyse canonique / Regression step for canonical analysis
C     [Dip*X]
      do 26 i=1,n
      do 26 j=1,m
      Xprime(j,i)=X(i,j)
   26 Z(i,j)=X(i,j)*Dip(i)
C     [X'*Dip*X] et inversion par GaussJ / [X'*Dip*X] and inversion using GaussJ
      call Produit(Xprime,Z,Inverse,m,n,m,nmax)
      call GaussJ(Inverse,m)
C     La matrice inversee est dans 'Inverse' / The inverted matrix is now in 'Inverse'
C
C Calcul des valeurs prevues par les regressions (Yhat) et des residus (Yres)
C Compute values fitted to regressions (Yhat) and residuals (Yres)
      do 28 i=1,m
      do 28 j=1,n
   28 Z(i,j)=Xprime(i,j)*Dipsq(j)
      call Produit(Inverse,Z,Yhat,m,m,n,nmax)
      call Produit(Yhat,Qbar,Z,m,n,p,nmax)
      call Produit(X,Z,Yhat,n,m,p,nmax)
      do 30 i=1,n
      do 30 j=1,p
      Yhat(i,j)=Yhat(i,j)*Dipsq(i)
   30 Yres(i,j)=Qbar(i,j)-Yhat(i,j)
      if((iprint.eq.2).or.(iprint.eq.4)) then
         if(langue.eq.1) write(LUT,*) 
     +              'Matrice Y-chapeau (prevue par les regressions)'
         if(langue.eq.2) write(LUT,*) 'Matrix Y-hat (fitted values)'
         write(LUT,*)
         do 32 i=1,n
   32    write(LUT,100) (Yhat(i,j), j=1,p)
         write(LUT,*)
         if(langue.eq.1) write(LUT,*) 'Matrice Yres (residus)'
         if(langue.eq.2) write(LUT,*) 'Matrix Yres (residuals)'
         write(LUT,*)
         do 34 i=1,n
   34    write(LUT,100) (Yres(i,j), j=1,p)
         write(LUT,*)
         endif
C Analyse canonique / Canonical analysis
C     if((ichoix2.ne.1).and.(ichoix2.ne.3)) goto 40
      if(irdacca.eq.1) then
         if(langue.eq.1) then
            write(LUT,*) '        *** Analyse canonique de ',
     +'redondance ***'
            else
            write(LUT,*) '        *** Canonical redundancy analysis ***'
            endif
         else
         if(langue.eq.1) then
            write(LUT,*) '        *** Analyse canonique des ',
     +'correspondances ***'
            else
            write(LUT,*) '        *** Canonical correspondence ',
     +'analysis ***'
            endif
         endif
      ican=1
      call Eigen(n,p,nmax,langue,ichoix1,irdacca,ican,nombre,nvalc,
     +           Yhat,totinert,Lambda,SingVal,U,UL,E,Z,vect,LUT,
     +           ichoix5,temp)
C     if(temp.eq.0.0) goto 40
      if(irdacca.eq.1) then
      call ScaleRDA(n,p,nmax,langue,ichoix3,ican,nvalc,Qbar,Yhat,
     +           Lambda,SingVal,U,F,Z,vect,LUT)
      else
      call ScaleCCA(n,p,nmax,langue,ichoix3,ican,nvalc,Qbar,Yhat,
     +           Dipmsq,Dpjmsq,Lambda,SingVal,U,Uhat,UL,V,Vhat,Z,
     +           iprint,LUT)
      endif
C Analyse de residus (Yres); ACP ou AFC / Analysis of residuals (Yres); PCA or CA
C  40 if((ichoix2.ne.2).and.(ichoix2.ne.3)) goto 99
   42 if(m.eq.0) then
        if(irdacca.eq.1) then
         if(langue.eq.1) then
            write(LUT,*) '        *** Analyse en composantes ',
     +'principales ***'
            else
            write(LUT,*) '        *** Principal component analysis ***'
            endif
        else
         if(langue.eq.1) then
            write(LUT,*) '        *** Analyse des correspondances ***'
            else
            write(LUT,*) '        *** Correspondence analysis ***'
            endif
        endif
      else
      if(langue.eq.1) write(LUT,*) '        *** Analyse des residus ***'
      if(langue.eq.2) write(LUT,*) '        *** Analysis of ',
     +'residuals ***'
      endif
      ican=2
      call Eigen(n,p,nmax,langue,ichoix1,irdacca,ican,nombre,nvalpr,
     +           Yres,totinert,Lambda,SingVal,U,UL,E,Z,vect,LUT,
     +           ichoix5,temp)
C     if(temp.eq.0.0) goto 99
      if(irdacca.eq.1) then
      call ScaleRDA(n,p,nmax,langue,ichoix3,ican,nvalpr,Qbar,Yres,
     +           Lambda,SingVal,U,F,Z,vect,LUT)
      else
      call ScaleCCA(n,p,nmax,langue,ichoix3,ican,nvalpr,Qbar,Yres,
     +           Dipmsq,Dpjmsq,Lambda,SingVal,U,Uhat,UL,V,Vhat,Z,
     +           iprint,LUT)
      endif
C ----------------------------------------------------------------------------
C   99 call time(tt)
      fin=secnds(debut)
C     if(langue.eq.1) write(LUT,108) fin
C     if(langue.eq.2) write(LUT,208) fin
      write(*,*)
      if(langue.eq.1) write(*,*) 'Fin du programme.'
      if(langue.eq.2) write(*,*) 'End of the program.'
      close(2)
      close(LUT)
      stop
  100 format(1x,10F10.5)
  101 format(' Inertie totale (variance totale de l''AC) =',F10.5/)
  201 format(' Total inertia (total CA variance) =',F10.5/)
  102 format(' Inertie totale =',f10.5,'   Variance totale =',f10.5/)
  202 format(' Total inertia =',f10.5,'   Total variance =',f10.5/)
C 108 format(' Temps de calcul:',F10.2,' secondes')
C 208 format(' Time spent:',F10.2,' seconds')
  109 format(/' Impression des resultats intermediaires?'/
     +        '   (0) Aucun resultat intermediaire'/ 
     +        '   (1) Matrices Q-bar (ou Y centree, en ACR) et X ',
     +'centree reduite'/
     +        '   (2) Matrices Y^ (prevue par les regressions) et ',
     +'Yres (residus)'/
     +        '   (3) Matrices U et U^ (en AFC-ACC)'/
     +        '   (4) Toutes ces matrices')
  209 format(/' Print intermediate calculation results?'/
     +        '   (0) None'/ 
     +        '   (1) Matrices Q-bar (or Y centred, in RDA) and X ',
     +'standardized,'/
     +        '   (2) Matrices Y^ (fitted to regressions) and ',
     +'Yres (residuals)'/
     +        '   (3) Matrices U and U^ (in CA-CCA)'/
     +        '   (4) All of these matrices')
  110 format(' Nombre max. de valeurs propres canoniques =',i3)
  210 format(' Maximum number of canonical eigenvalues =',i3)
  111 format(' Nombre max. de valeurs propres non canoniques =',i3)
  211 format(' Maximum number of non-canonical eigenvalues =',i3)
  112 format(/' Methode d''analyse d''inertie: '/
     +        '   (1) Householder'/
     +        '   (2) Decomposition en valeurs singulieres')
  212 format(/' Method of eigenanalysis: '/
     +        '   (1) Householder'/
     +        '   (2) Singular value decomposition (SVD)')
  113 format(/' Calculs a realiser: '/
     +        '   (1) Analyse canonique'/
     +        '   (2) Analyse de la matrice des residus'/
     +        '   (3) Les deux')
  213 format(/' Compute the following: '/
     +        '   (1) Canonical analysis'/
     +        '   (2) Analysis of the residual matrix'/
     +        '   (3) Both')
  114 format(/' Cadrage des lignes et des colonnes:'/
     +        '   (1) Lignes-sites (mat. F)',
     +              ' au centroide des colonnes-especes (mat. V)'/
     +        '   (2) Colonnes-especes (mat. F-hat)',
     +              ' au centroide des lignes-sites (mat. V-hat)')
  214 format(/' Scaling of rows and columns:'/
     +        '   (1) Row-sites (mat. F) at centroids',
     +              ' of column-species (mat. V)'/
     +        '   (2) Column-species (mat. F-hat) at centroids',
     +              ' of row-sites (mat. V-hat)')
  115 format(/' Ecrire les resultats'/
     +        '   (1) A l''ecran'/
     +        '   (2) Dans un fichier')
  215 format(/' Write results'/
     +        '   (1) To the screen'/
     +        '   (2) To an output file')
  116 format(/' Methode d''ordination:'/
     +        '   (1) ACR (analyse canonique de redondance), ou ',
     +'ACP si m = 0'/
     +        '   (2) ACC (analyse canonique des correspondances), ',
     +'ou AFC si m = 0')
  216 format(/' Ordination method:'/
     +        '   (1) RDA (redundancy analysis), or PCA if m = 0'/
     +        '   (2) CCA (canonical correspondence analysis), or  ',
     +'CA if m = 0')
  117 format(/' Cadrage des lignes et des colonnes:'/
     +        '   (1) Distances entre objets preservees'/
     +        '   (2) Correlations entre variables preservees')
  217 format(/' Scaling of rows and columns:'/
     +        '   (1) Distance biplot: distances among objects',
     +              ' approximate Euclidean distances'/
     +        '   (2) Correlation biplot: angles reflect',
     +              ' correlations among variables')
      end
      
      Subroutine Eigen(n,p,nmax,langue,ichoix1,irdacca,ican,nombre,
     + nvalpr,Yhat,totinert,Lambda,SingVal,U,UL,E,Z,vect,LUT,
     +ichoix5,temp)
      Integer p,nombre(nmax)
      Real*8 Yhat(nmax,nmax),totinert
      Real*8 Lambda(nmax),SingVal(nmax),U(nmax,nmax),UL(nmax,nmax),
     +E(nmax)
      Real*8 Z(nmax,nmax),vect(nmax),temp,dflnm1
      dflnm1=dfloat(n-1)
      limite=min(n,p)
      epsilon= -0.0001
C Householder: calcul de la matrice Yhat'Yhat, puis des valeurs et vecteurs propres 
C Compute SSCP matrix (Yhat'Yhat), followed by eigenvalues and eigenvectors
C
C The program structure with GOTOs, used below, is due to the fact that the 
C Lahey Fortran compiler did not accept the previously used structure with 
C IF...THEN...ELSE...ENDIF with an imbedded GOTO.
      if(ichoix1.eq.1) then
            do 2 i=1,n
            do 2 j=1,p
    2       Z(j,i)=Yhat(i,j)
            if(n.lt.p) goto 80
            if((n.eq.p).and.(ichoix5.eq.2)) goto 80
            call Produit(Z,Yhat,U,p,n,p,nmax)
            call tred2(U,p,nmax,Lambda,E)
            call tqli(Lambda,E,p,nmax,U)
            goto 81
C Householder pour matrices ou n < p / Householder for matrices where n < p
   80       call Produit(Yhat,Z,U,n,p,n,nmax)
            call tred2(U,n,nmax,Lambda,E)
            call tqli(Lambda,E,n,nmax,U)
            do 4 i=1,limite
            if(Lambda(i).lt.0.0) then
               if(Lambda(i).ge.epsilon) then
                  Lambda(i)=0.0
                  else
                  if(langue.eq.1) write(*,110) i,Lambda(i)
                  if(langue.eq.2) write(*,210) i,Lambda(i)
                  stop
                  endif
               endif
    4       SingVal(i)=dsqrt(Lambda(i))
   81       continue   
         else
C Decomposition en valeurs singulieres / Singular value decomposition (SVD)
            if(n.lt.p) goto 84
            if((n.eq.p).and.(ichoix5.eq.2)) goto 84
            do 14 i=1,n
            do 14 j=1,p
   14       Z(i,j)=Yhat(i,j)
            call SVDcmp(n,p,Z,U,SingVal,vect,nmax)
            goto 85
C Idem, pour matrices ou n < p / Same, for matrices where n < p
   84       do 18 i=1,n
            do 18 j=1,p
   18       Z(j,i)=Yhat(i,j)
            call SVDcmp(p,n,Z,U,SingVal,vect,nmax)
            do 19 i=1,n
            do 19 j=1,p
   19       Z(j,i)=Yhat(i,j)
   85       continue
C
            do 20 i=1,limite
   20       Lambda(i)=SingVal(i)**2
         endif
C Transformation de U lorsque n < p (eq. 9.39)
C Transformation of U when n < p (eq. 9.39)
      if((n.lt.p).or.((n.eq.p).and.(ichoix5.eq.2))) then
C        U = Yhat' * Eigenvectors * (Singular values)-1
C        Z contient Yhat'. UL est une matrice intermediaire de calcul.
C        Z contains Yhat'. UL is used here as a scratch file.
         do 22 i=1,n
         do 22 j=1,n
   22    UL(i,j)=U(i,j)/SingVal(j)
         call Produit(Z,UL,U,p,n,n,nmax)
         endif
C Quand n>p, on pourrait utiliser la matrice Z issue de SVDcmp pour calculer
C directement les "Site scores LCEV", mais pas pour calculer les matrices Vhat et F.
C When n>p, we could use matrix Z produced by SVDcmp to compute the "site scores 
C LCEV" directly, but it cannot be used to compute matrices Vhat and F.
C
C Les valeurs propres sont dans Lambda; les vecteurs propres normalises sont dans U.
C The eigenvalues are in vector Lambda; the normalized eigenvectors are in U.
C
C Tri des valeurs et vecteurs propres en ordre decroissant des valeurs propres.
C Put the eigenvalues and corresponding eigenvectors in descending order.
C Phase 1: Trier les valeurs propres ainsi que le vecteur d'entiers "nombre"
C Phase 1: Sort eigenvalues together with the vector of integers "nombre"
         do 30 i=1,limite
   30    nombre(i)=i
         do 36 j=2,limite
            temp=Lambda(j)
            nn=nombre(j)
            do 32 i=j-1,1,-1
               if(Lambda(i).gt.temp) goto 34
               Lambda(i+1)=Lambda(i)
               nombre(i+1)=nombre(i)
   32          continue
            i=0
   34       Lambda(i+1)=temp
            nombre(i+1)=nn
   36    continue
C Phase 2: Trier U selon le nouvel ordre donne par "nombre"; "vect" est un tampon.
C Phase 2: Sort U according to new order of "nombre". Use "vect" as buffer.
         do 42 jj=1,p
         do 38 j=1,limite
   38    vect(j)=U(jj,j)
         do 40 j=1,limite
   40    U(jj,j)=vect(nombre(j))
   42    continue
C Phase 3: eliminer les valeurs propres nulles
C Phase 3: eliminate null eigenvalues
      nval=0
      do 44 i=1,limite
      if(Lambda(i).gt.0.000001) then
         nval=nval+1
         else
         goto 46
         endif
   44 continue
   46 if(nval.lt.nvalpr) nvalpr=nval
      if(nval.eq.0) then
         temp=0.0
         goto 56
         endif
C
C Impression des valeurs propres / Print eigenvalues
      if(ican.eq.1) then
         if(langue.eq.1) write(LUT,101)
         if(langue.eq.2) write(LUT,201)
         else
         if(langue.eq.1) write(LUT,102)
         if(langue.eq.2) write(LUT,202)
         endif
      if(irdacca.eq.1) then
         do 48 j=1,nvalpr
         SingVal(j)=dsqrt(Lambda(j)/dflnm1)
   48    Lambda(j)=Lambda(j)/dflnm1
         else
         do 50 j=1,nvalpr
   50    SingVal(j)=dsqrt(Lambda(j))
         endif
      write(LUT,100) (Lambda(i), i=1,nvalpr)
      if(irdacca.eq.1) then
         if(langue.eq.1) write(LUT,108) 
         if(langue.eq.2) write(LUT,208)
         else
         if(langue.eq.1) write(LUT,103) 
         if(langue.eq.2) write(LUT,203)
         endif
      write(LUT,100) (100.0*Lambda(i)/totinert, i=1,nvalpr)
      temp=0.0
      do 52 i=1,nvalpr
      temp=temp+Lambda(i)
   52 vect(i)=temp
      if(irdacca.eq.1) then
         if(langue.eq.1) write(LUT,109) 
         if(langue.eq.2) write(LUT,209)
         else
         if(langue.eq.1) write(LUT,104)
         if(langue.eq.2) write(LUT,204)
         endif
      write(LUT,100) (100.0*vect(i)/totinert, i=1,nvalpr)
      temp=0.0
      do 54 i=1,nvalpr
   54 temp=temp+Lambda(i)
      if(ican.eq.1) then
         if(langue.eq.1) write(LUT,105)
         if(langue.eq.2) write(LUT,205)
         write(LUT,100) (100.0*vect(i)/temp, i=1,nvalpr)
         endif
   56 if(ican.eq.1) then
         if(langue.eq.1) write(LUT,106) temp
         if(langue.eq.2) write(LUT,206) temp
         else
         if(langue.eq.1) write(LUT,107) temp
         if(langue.eq.2) write(LUT,207) temp
         endif
         write(LUT,*)
      return
  100 format(1x,10F10.5)
  101 format(/' Valeurs propres canoniques')
  201 format(/' Canonical eigenvalues')
  102 format(/' Valeurs propres non canoniques')
  202 format(/' Non-canonical eigenvalues')
  103 format(/' % de la variance totale de l''AFC')
  203 format(/' % of total variance of CA')
  104 format(/' % cumulatif de la variance totale de l''AFC')
  204 format(/' Cumulative % of total variance of CA')
  105 format(/' % cumulatif de la variance canonique')
  205 format(/' Cumulative % of canonical variance')
  106 format(/' Somme des valeurs propres canoniques',F10.5)
  206 format(/' Sum of all canonical eigenvalues',F10.5)
  107 format(/' Somme des valeurs propres non canoniques',F10.5)
  207 format(/' Sum of non-canonical eigenvalues',F10.5)
  108 format(/' % de la variance totale de l''ACP')
  208 format(/' % of total variance of PCA')
  109 format(/' % cumulatif de la variance totale de l''ACP')
  209 format(/' Cumulative % of total variance of PCA')
  110 format(/' La valeur propre',i3,' est negative (',f10.5,
     +') -- Recalculez par la decomposition en valeurs ',
     +'singulieres.')               
  210 format(/' Eigenvalue',i3,' is negative (',f10.5,
     +') -- Recompute using singular value decomposition.')          
      end

      Subroutine ScaleRDA(n,p,nmax,langue,ichoix3,ican,nvalpr,
     +           Qbar,Yhat,Lambda,SingVal,U,F,Z,vect,LUT)
      Integer p
      Real*8 Qbar(nmax,nmax),Yhat(nmax,nmax)
      Real*8 Lambda(nmax),SingVal(nmax),U(nmax,nmax)
      Real*8 F(nmax,nmax)
      Real*8 Z(nmax,nmax),vect(nmax)
C Cadrage = 1: U, F et Z / Scaling = 1: U, F and Z
C Qbar contient Y centre / Qbar contains centred Y
      if(ican.eq.1) call Produit(Qbar,U,F,n,p,nvalpr,nmax) 
      call Produit(Yhat,U,Z,n,p,nvalpr,nmax) 
      if(ichoix3.eq.1) then
         if(langue.eq.1) write(LUT,*) 
     +      'Cadrage = 1: preserve les distances entre objets'
         if(langue.eq.2) write(LUT,*) 'Scaling = 1: distance biplot'
         else
C Cadrage = 2: U, F et Z / Scaling = 2: U, F and Z
         if(langue.eq.1) write(LUT,*) 
     +      'Cadrage = 2: preserve les correlations entre descripteurs'
         if(langue.eq.2) write(LUT,*) 'Scaling = 2: correlation biplot'
C        Calculer U * Lambda**0.5 / Compute U * Lambda**0.5
         do 22 i=1,p
         do 22 j=1,nvalpr
   22    U(i,j)=U(i,j)*SingVal(j)
C        Recadrer F a variance = 1 / Rescale F to variance = 1
         if(ican.eq.1) then
            do 24 i=1,n
            do 24 j=1,nvalpr
   24       F(i,j)=F(i,j)/SingVal(j)
            endif
C        Recadrer Z a variance = 1 / Rescale Z to variance = 1
         do 26 i=1,n
         do 26 j=1,nvalpr
   26    Z(i,j)=Z(i,j)/SingVal(j)
         endif
C
C Impression / Print
C     Vecteurs propres / Eigenvectors
      write(LUT,*)
      if(ichoix3.eq.1) then
         if(langue.eq.1) write(LUT,*) 'Vecteurs propres normalises (U)'
         if(langue.eq.2) write(LUT,*) 'Normalized eigenvectors (U)'
         else
         if(langue.eq.1) write(LUT,*) 'Vecteurs propres (U * ',
     +'Lambda**0.5)'
         if(langue.eq.2) write(LUT,*) 'Eigenvectors (U * Lambda**0.5)'
         endif
      write(LUT,*)
      do 10 i=1,p
   10 write(LUT,100) (U(i,j), j=1,nvalpr)
      write(LUT,*)
C     Calculer la longueur des vecteurs propres / Compute length of eigenvectors
      do 28 j=1,nvalpr
   28 vect(j)=0.0
      do 30 i=1,p
      do 30 j=1,nvalpr
   30 vect(j)=vect(j)+U(i,j)**2
      if(langue.eq.1) write(LUT,*) 'Sommes de carres'
      if(langue.eq.2) write(LUT,*) 'Sums of squares'
      write(LUT,100) (vect(j), j=1,nvalpr)
      if(langue.eq.1) write(LUT,*) 'Longueurs'
      if(langue.eq.2) write(LUT,*) 'Lengths'
      write(LUT,100) (dsqrt(vect(j)), j=1,nvalpr)
      write(LUT,*)
C     Position des objets / Object scores
      if(ican.eq.1) then
         if(langue.eq.1) write(LUT,*) 'Position des objets (F)'
         if(langue.eq.2) write(LUT,*) 'Object scores (F)'
         write(LUT,*)
         do 12 i=1,n
   12    write(LUT,100) (F(i,j), j=1,nvalpr)
         write(LUT,*)
C     Calculer la longueur des vecteurs de F / Compute length of the vectors of F
         do 32 j=1,nvalpr
   32    vect(j)=0.0
         do 34 i=1,n
         do 34 j=1,nvalpr
   34    vect(j)=vect(j)+F(i,j)**2
C         if(langue.eq.1) write(LUT,*) 'Sommes de carres'
C         if(langue.eq.2) write(LUT,*) 'Sums of squares'
C         write(LUT,100) (vect(j), j=1,nvalpr)
         write(LUT,*) 'Variances'
         write(LUT,100) (vect(j)/dfloat(n-1), j=1,nvalpr)
         write(LUT,*)
         endif
C     Position des objets dans l'expace X / Object scores in space X
      if(ican.eq.1) then
         if(langue.eq.1) write(LUT,*) 
     +               'Positions des objets/comb. lin. var. env. (Z)'
         if(langue.eq.2) write(LUT,*) 
     +               'Object scores/linear comb. envir. var. (Z)'
         else
         if(langue.eq.1) write(LUT,*) 'Position des objets (F)'
         if(langue.eq.2) write(LUT,*) 'Object scores (F)'
         endif
      write(LUT,*)
      do 14 i=1,n
   14 write(LUT,100) (Z(i,j), j=1,nvalpr)
      write(LUT,*)
C     Calculer la longueur des vecteurs de Z / Compute length of the vectors of Z
      do 36 j=1,nvalpr
   36 vect(j)=0.0
      do 38 i=1,n
      do 38 j=1,nvalpr
   38 vect(j)=vect(j)+Z(i,j)**2
C      if(langue.eq.1) write(LUT,*) 'Sommes de carres'
C      if(langue.eq.2) write(LUT,*) 'Sums of squares'
C      write(LUT,100) (vect(j), j=1,nvalpr)
      write(LUT,*) 'Variances'
      write(LUT,100) (vect(j)/dfloat(n-1), j=1,nvalpr)
      write(LUT,*)
C
      return
  100 format(1x,10F10.5)
      end

      Subroutine ScaleCCA(n,p,nmax,langue,ichoix3,ican,nvalpr,Qbar,Yhat,
     +           Dipmsq,Dpjmsq,Lambda,SingVal,U,Uhat,UL,V,Vhat,Z,
     +           iprint,LUT)
      Integer p
      Real*8 Qbar(nmax,nmax),Yhat(nmax,nmax)
      Real*8 Dipmsq(nmax),Dpjmsq(nmax)
      Real*8 Lambda(nmax),SingVal(nmax),U(nmax,nmax),Uhat(nmax,nmax),
     +       UL(nmax,nmax)
      Real*8 V(nmax,nmax),Vhat(nmax,nmax)
      Real*8 Z(nmax,nmax)
C
C AFC-ACC: Calcul de Uhat / CA-CCA: Compute Uhat
      do 45 i=1,p
      do 45 j=1,nvalpr
   45 UL(i,j)=U(i,j)/SingVal(j)
      call Produit(Qbar,UL,Uhat,n,p,nvalpr,nmax) 
C
C Impression des vecteurs propres / Print eigenvectors
      if(iprint.ge.3) then
         if(langue.eq.1) write(LUT,*) 'Vecteurs propres normalises (U)'
         if(langue.eq.2) write(LUT,*) 'Normalized eigenvectors (U)'
         write(LUT,*)
         do 48 i=1,p
   48    write(LUT,100) (U(i,j), j=1,nvalpr)
         write(LUT,*)
C
         if(langue.eq.1) write(LUT,*) 'Vecteurs propres normalises (U^)'
         if(langue.eq.2) write(LUT,*) 'Normalized eigenvectors (U^)'
         write(LUT,*)
         do 50 i=1,n
   50    write(LUT,100) (Uhat(i,j), j=1,nvalpr)
         write(LUT,*)
         endif
C Cadrage en ACC / Scaling in CCA
C
C Coordonnees des especes, cadrage = 1 / Species scores, scaling = 1: V = Dpj-0.5 * U
C   Dpjmsq contient Dpj-0.5
      do 52 i=1,p
      do 52 j=1,nvalpr
   52 V(i,j)=U(i,j)*Dpjmsq(i)
C
C Coordonnees des sites, cadrage = 2 / Site scores, scaling = 2: V^ = Dip-0.5*U^
C (Inutile pour l'analyse des residus) / (Useless in the analysis of residuals)
C   Dipmsq contient Dip-0.5
C   Uhat contient U^
      if(ican.eq.1) then
         do 56 i=1,n
         do 56 j=1,nvalpr
   56    Vhat(i,j)=Uhat(i,j)*Dipmsq(i)
         endif
C
C Cadrage = 1 / Scaling = 1:
      if(ichoix3.eq.1) then
         if(langue.eq.1) write(LUT,*) 'Cadrage = 1: sites au ',
     +'centroide des especes'
         if(langue.eq.2) write(LUT,*) 'Scaling = 1: sites at ',
     +'centroids of species'
         write(LUT,*)
C     Lignes / Site scores: F = V^ * Lambda+0.5
C     (Inutile pour l'analyse des residus) / (Useless in the analysis of residuals)
C     C contient les valeurs propres / C contains the eigenvalues
         if(ican.eq.1) then
            do 58 i=1,n
            do 58 j=1,nvalpr
   58       Vhat(i,j)=Vhat(i,j)*SingVal(j)
            endif
C
C     Lignes CLVE / Site scores LCEV: Z = Dip-0.5 * Y^ * U
C     Yhat contient Y^ / Yhat contains Y^
C     Dipmsq contient Dip-0.5 / Dipmsq contains Dip-0.5
         call Produit(Yhat,U,Z,n,p,nvalpr,nmax) 
         do 64 i=1,n
         do 64 j=1,nvalpr
   64    Z(i,j)=Z(i,j)*Dipmsq(i)
C
C     Impression: V, F, Z / Print V, F, Z
         if(langue.eq.1) write(LUT,*) 'Colonnes (especes, matrice V)'
         if(langue.eq.2) write(LUT,*) 'Species scores (matrice V)'
         write(LUT,*)
         do 54 i=1,p
   54    write(LUT,100) (V(i,j), j=1,nvalpr)
         write(LUT,*)
C
         if(ican.eq.1) then
            if(langue.eq.1) write(LUT,*) 'Lignes (sites, matrice F)'
            if(langue.eq.2) write(LUT,*) 'Site scores (matrice F)'
            write(LUT,*)
            do 60 i=1,n
   60       write(LUT,100) (Vhat(i,j), j=1,nvalpr)
            write(LUT,*)
            endif
C
         if(ican.eq.1) then
            if(langue.eq.1) write(LUT,*) 
     +         'Lignes / comb. lin. var. env. (sites, matrice Z)'
            if(langue.eq.2) write(LUT,*) 
     +         'Site scores/ linear comb. envir. var. (matrice Z)'
            else
            if(langue.eq.1) write(LUT,*) 'Lignes (sites, matrice F)'
            if(langue.eq.2) write(LUT,*) 'Site scores (matrice F)'
            endif
         write(LUT,*)
         do 66 i=1,n
   66    write(LUT,100) (Z(i,j), j=1,nvalpr)
         write(LUT,*)
C
C Cadrage = 2 / Scaling = 2:
      else
         if(langue.eq.1) write(LUT,*) 'Cadrage = 2: especes au ',
     +'centroide des sites'
         if(langue.eq.2) write(LUT,*) 'Scaling = 2: species at ',
     +'centroids of sites'
         write(LUT,*)
C     Colonnes / Species scores: F^ = V * Lambda+0.5
C     Lambda contient les valeurs propres / Lambda contains the eigenvalues
         do 68 i=1,p
         do 68 j=1,nvalpr
   68    V(i,j)=V(i,j)*SingVal(j)
C
C     Lignes CLVE / Site scores LCEV: Z = Dip-0.5 * Y^ * U * lambda-0.5
C     Yhat contient Y^ / Yhat contains Y^
C     UL contient (U * lambda-0.5) / UL contains (U * lambda-0.5)
C     Dipmsq contient Dip-0.5 / Dipmsq contains Dip-0.5
         call Produit(Yhat,UL,Z,n,p,nvalpr,nmax) 
         do 72 i=1,n
         do 72 j=1,nvalpr
   72    Z(i,j)=Z(i,j)*Dipmsq(i)
C
C     Impression: Fhat, Vhat, Z / Print Fhat, Vhat, Z
         if(langue.eq.1) write(LUT,*) 'Colonnes (especes, matrice F^)'
         if(langue.eq.2) write(LUT,*) 'Species scores (matrice F^)'
         write(LUT,*)
         do 70 i=1,p
   70    write(LUT,100) (V(i,j), j=1,nvalpr)
         write(LUT,*)
C
         if(ican.eq.1) then
            if(langue.eq.1) write(LUT,*) 'Lignes (sites, matrice V^)'
            if(langue.eq.2) write(LUT,*) 'Site scores (matrice V^)'
            write(LUT,*)
            do 62 i=1,n
   62       write(LUT,100) (Vhat(i,j), j=1,nvalpr)
            write(LUT,*)
            endif
C
         if(ican.eq.1) then
            if(langue.eq.1) write(LUT,*) 'Lignes / comb. lin. ',
     +'var. env. (sites, matrice Z)'
            if(langue.eq.2) write(LUT,*) 'Site scores/ linear ',
     +'comb. envir. var. (matrice Z)'
            else
            if(langue.eq.1) write(LUT,*) 'Lignes (sites, matrice V^)'
            if(langue.eq.2) write(LUT,*) 'Site scores (matrice V^)'
            endif
         write(LUT,*)
         do 74 i=1,n
   74    write(LUT,100) (Z(i,j), j=1,nvalpr)
         write(LUT,*)
      endif
      return
  100 format(1x,10F10.5)
      end
      
      Subroutine Produit(Z1,Z2,Z3,n1,n2,n3,nmax)
      Real*8 Z1(nmax,nmax),Z2(nmax,nmax),Z3(nmax,nmax),temp
C Z1 * Z2 = Z3
      do 8 i=1,n1
      do 8 j=1,n3
      temp=0.0
      do 6 k=1,n2
    6 temp=temp+Z1(i,k)*Z2(k,j)
    8 Z3(i,j)=temp
      return
      end

      Subroutine ReadData(n,p,m,nmax,Y,X,langue,LUT)
      Integer p
      Real*8 Y(nmax,nmax),X(nmax,nmax)
      Character*79 nom
C
C     Lecture du tableau de donnees / Read the data file
      if(langue.eq.1) write(*,*) 'Fichier de donnees?'
      if(langue.eq.2) write(*,*) 'Data file?'
      read(*,'(A)') nom
      open(2,file=nom)
      read(2,*) n,p,m
      if(langue.eq.1) write(LUT,103) nom,n,p,m
      if(langue.eq.2) write(LUT,203) nom,n,p,m
      if((n.gt.nmax).or.(p.gt.nmax)) then
         if(langue.eq.1) write(LUT,101) 
         if(langue.eq.2) write(LUT,201)
         stop
         endif
      if(m.gt.n) then
         if(langue.eq.1) write(LUT,102) 
         if(langue.eq.2) write(LUT,202)
         stop
         endif
      do 10 i=1,n
   10 read(2,*) (Y(i,j), j=1,p),(X(i,k), k=1,m)
C      write(LUT,*) 'Matrice Y'
C      write(LUT,*)
C      do 12 i=1,n
C   12 write(LUT,100) (Y(i,j), j=1,p)
C      write(LUT,*)
C      write(LUT,*) 'Matrice X'
C      write(LUT,*)
C      do 14 i=1,n
C   14 write(LUT,100) (X(i,k), k=1,m)
C      write(LUT,*)
      return
  100 format(1x,10F10.5)
  101 format(' Matrice Y trop grande. Redimensionnez le programme.')
  201 format(' The Y matrix is too large. Redimension the program.')
  102 format(' La matrice X contient trop de variables explicatives ',
     +'(m > n).')
  202 format(' The X matrix contains too many explanatory variables ',
     +'(m > n).')
  103 format(/' Fichier de donnees: ',a30/
     +        i6,' objets'/
     +        i6,' variables reponse (matrice Y) '/
     +        i6,' variables explicatives (matrice X)')
  203 format(/' Input file: ',a30/
     +        i6,' objects'/
     +        i6,' response variables (matrix Y)'/
     +        i6,' explanatory variables (matrix X)')
      end

      Subroutine TransRDA(n,p,m,nmax,Y,X,temp,
     +                    sx,sx2,xbar,sdev,iprint,langue,LUT)
      Integer p
      Real*8 Y(nmax,nmax),X(nmax,nmax)
      Real*8 sx(nmax),sx2(nmax),xbar(nmax),sdev(nmax),temp,dfln,dflnm1
C Transformation des matrices Y et X pour l'ACP ou l'analyse de redondance
C Transformation of matrices Y and X prior to PCA or redundancy analysis
C
C Centrage des colonnes de Y / Centring the column vectors of Y
      dfln=dfloat(n)
      dflnm1=dfloat(n-1)
      do 8 j=1,p
    8 sx(j)=0.0
      do 10 i=1,n
      do 10 j=1,p
   10 sx(j)=sx(j)+Y(i,j)
      do 12 j=1,p
   12 xbar(j)=sx(j)/dfln
      do 14 i=1,n
      do 14 j=1,p
   14 Y(i,j)=Y(i,j)-xbar(j)
C
C Calcul de l'inertie totale de Y / Compute total inertia in Y
      temp=0.0
      do 16 i=1,n
      do 16 j=1,p
      temp=temp+Y(i,j)**2
   16 continue
C
C Transformation de X / Standardization of X
      do 20 k=1,m
      sx(k)=0.0
   20 sx2(k)=0.0
      do 22 i=1,n
      do 22 k=1,m
      sx(k)=sx(k)+X(i,k)
   22 sx2(k)=sx2(k)+X(i,k)*X(i,k)
      do 24 k=1,m
      xbar(k)=sx(k)/dfln
   24 sdev(k)=dsqrt((sx2(k)-(sx(k)**2/dfln))/dflnm1)
      do 26 k=1,m
      if(sdev(k).eq.0.0) then
         if(langue.eq.1) write(LUT,*) 'Variance nulle pour ',
     +'variable X no ',k
         if(langue.eq.2) write(LUT,*) 'Variance = 0 for ',
     +'variable X no. ',k
         stop
         endif
   26 continue
      do 28 i=1,n
      do 28 k=1,m
   28 X(i,k)=(X(i,k)-xbar(k))/sdev(k)
      if((iprint.ne.1).and.(iprint.ne.4)) return
C
      if(langue.eq.1) write(LUT,*) 'Matrice Y centree'
      if(langue.eq.2) write(LUT,*) 'Centred matrix Y'
      write(LUT,*)
      do 32 i=1,n
   32 write(LUT,100) (Y(i,j), j=1,p)
      write(LUT,*)
      if(m.eq.0) return
      if(langue.eq.1) write(LUT,*) 'Matrice X centree reduite'
      if(langue.eq.2) write(LUT,*) 'Standardized X matrix'
      write(LUT,*)
      do 34 i=1,n
   34 write(LUT,100) (X(i,k), k=1,m)
      write(LUT,*)
      return
  100 format(1x,10F10.5)
      end

      Subroutine TransCCA(n,p,m,nmax,Y,Qbar,X,Fip,Dip,Dpj,Ftot,temp,
     +                   sx,sx2,xbar,sdev,iprint,langue,LUT)
      Integer p
      Real*8 Y(nmax,nmax),Qbar(nmax,nmax),X(nmax,nmax)
      Real*8 Fip(nmax),Dip(nmax),Dpj(nmax),Ftot
      Real*8 sx(nmax),sx2(nmax),xbar(nmax),sdev(nmax),temp
C Transformation de Y et X pour l'AFC ou l'analyse canonique des correspondances
C Transformation of Y and X prior to CA or canonical correspondence analysis
      do 2 i=1,n
    2 Fip(i)=0.0
      do 4 j=1,p
    4 Dpj(j)=0.0
      Ftot=0.0
      do 6 i=1,n
      do 6 j=1,p
      Fip(i)=Fip(i)+Y(i,j)
    6 Dpj(j)=Dpj(j)+Y(i,j)
      do 8 j=1,p
    8 Ftot=Ftot+Dpj(j)
      do 9 j=1,p
    9 Dpj(j)=Dpj(j)/Ftot
      do 10 i=1,n
   10 Dip(i)=Fip(i)/Ftot
C Transformation de Y en Q=Y/Ftot et Qbar / Transformation of Y into Q=Y/Ftot and Qbar
      do 12 i=1,n
      do 12 j=1,p
   12 Y(i,j)=Y(i,j)/Ftot
      do 14 i=1,n
      do 14 j=1,p
      temp=dsqrt(Dip(i)*Dpj(j))
   14 Qbar(i,j)=(Y(i,j) - Dip(i)*Dpj(j))/temp
C
C Calcul de l'inertie totale de Qbar / Compute total inertia in Qbar
      temp=0.0
      do 16 i=1,n
      do 16 j=1,p
      temp=temp+(Qbar(i,j))**2
   16 continue
C
C Transformation de X / Standardization of X
      do 20 k=1,m
      sx(k)=0.0
   20 sx2(k)=0.0
      do 22 i=1,n
      do 22 k=1,m
      sx(k)=sx(k)+Fip(i)*X(i,k)
   22 sx2(k)=sx2(k)+Fip(i)*X(i,k)*X(i,k)
      do 24 k=1,m
      xbar(k)=sx(k)/Ftot
   24 sdev(k)=dsqrt((sx2(k)-(sx(k)**2/Ftot))/Ftot)
      do 26 k=1,m
      if(sdev(k).eq.0.0) then
         if(langue.eq.1) write(LUT,*) 'Variance nulle pour ',
     +'variable X no ',k
         if(langue.eq.2) write(LUT,*) 'Variance = 0 for ',
     +'variable X no. ',k
         stop
         endif
   26 continue
      do 28 i=1,n
      do 28 k=1,m
   28 X(i,k)=(X(i,k)-xbar(k))/sdev(k)
      if((iprint.ne.1).and.(iprint.ne.4)) return
C
      write(LUT,*)
      if(langue.eq.1) write(LUT,*) 'Matrice Y transformee (Q-bar)'
      if(langue.eq.2) write(LUT,*) 'Transformed Y matrix (Q-bar)'
      write(LUT,*)
      do 32 i=1,n
   32 write(LUT,100) (Qbar(i,j), j=1,p)
      write(LUT,*)
      if(m.eq.0) return
      if(langue.eq.1) write(LUT,*) 'Matrice X centree reduite'
      if(langue.eq.2) write(LUT,*) 'Standardized X matrix'
      write(LUT,*)
      do 34 i=1,n
   34 write(LUT,100) (X(i,k), k=1,m)
      write(LUT,*)
      return
  100 format(1x,10F10.5)
      end
         
      Subroutine GaussJ(A,nn)
C Parameter n should have the same value as parameter nmax, in the program's header
      Parameter (mp=1,m=1,n=100)
      Real*8 A(n,n),B(n,mp),val,big,pivinv,dum
      Integer*4 ipiv(n), indxr(n), indxc(n)
c-----------------------------------------------------------------------
c 
c Linear equation solution by Gauss-Jordan elimination.
c From 'Numerical Recipes' (Press et al., 1986), p. 28-29.
c A is an input matrix of 'nn x nn' elements, stored in a array of physical
c dimensions 'n x n'. B is an input matrix of 'nn x m' containing the m
c right-hand side vectors, stored in an array of physical dimension 'n x mp'.
c [In this implementation, B only contains a column vector of zero on start.]
c On output, A is replaced by its matrix inverse, and B is replaced by
c the corresponding set of solution vectors.
c 
c Note: a singular matrix causes an appropriate "pause" message. 
c 
c The integer arrays IPIV, INDXR and INDXC are used for bookkeeping on the
c pivoting. 'n' should be as large as the largest anticipated value of 'nn'.
c 
c Modified for GSLIB from Numerical Recipes (1986), Section 2.1, p. 28-29.
c 
C Solves the system: [B(nxm)|identity] = A(nxn).[X(nxm)|invA] where m=1.
c X (stored in B on input) is the initial solution vector of the set of
c linear equations; on output, B is the set of regression coefficients.
c
c Pour realiser une regression lineaire:
c au depart, B est le vecteur des valeurs X'y;
c A est la matrice [X'X] a inverser;
C a la fin du programme, B contient le vecteur des coefficients de regression.
c-----------------------------------------------------------------------
      if (nn .lt. 1) stop 'illogical nn in Gaussj.'
C     Initialisation de b
      do 2 i=1,nn
      do 2 j=1,m
    2 b(i,j)=0.0
C
      do 10 j = 1, nn
      ipiv(j) = 0
   10 continue 
C Beginning the main loop (110) over the columns to be reduced
      do 110 i = 1, nn
        big = 0.
C Beginning the outer loop (30) of the search for a pivot element
        do 30 j = 1, nn
          if (ipiv(j) .ne. 1) then 
            do 20 k = 1, nn
              if (ipiv(k) .eq. 0) then 
                if (abs(a(j,k)) .ge. big) then 
                  big = abs(a(j,k))
                  irow = j
                  icol = k
                end if 
              else if (ipiv(k) .gt. 1) then 
                pause 'singular matrix'
              end if 
   20       continue 
          end if 
   30   continue 
        ipiv(icol) = ipiv(icol) + 1
C We now have the pivot element, so we interchange rows, if needed, to put
C the pivot element on the diagonal. The columns are not physically
C interchanged, only relabeled: INDX(i), the column of the i-th pivot, is
C the i-th column that is reduced, while INDXR(i) is the row in which that
C pivot element was originally located. If INDXR(i)<>INDXC(i) there is an
C implied column interchange. With this form of bookkeeping, the solution 
C B's will end up in the correct order, and the inverse matrix will be
C scrambled by columns.
        if (irow .ne. icol) then 
          do 40 l = 1, nn
            dum = a(irow,l)
            a(irow,l) = a(icol,l)
            a(icol,l) = dum
   40     continue 
          do 50 l = 1, m
            dum = b(irow,l)
            b(irow,l) = b(icol,l)
            b(icol,l) = dum
   50     continue 
        end if 
        indxr(i) = irow
        indxc(i) = icol
C We are now ready to divide the pivot row by the pivot element, 
C located at Irow and Icol
        if (dabs(a(icol,icol)) .le. 0.00000001) pause 'Singular matrix.'
        pivinv = 1. / a(icol,icol)
        a(icol,icol) = 1.
        do 60 l = 1, nn
          a(icol,l) = a(icol,l) * pivinv
   60   continue 
        do 70 l = 1, m
          b(icol,l) = b(icol,l) * pivinv
   70   continue 
C Next we reduce the rows, except for the pivot one, of course
        do 100 ll = 1, nn
          if (ll .ne. icol) then 
            dum = a(ll,icol)
            a(ll,icol) = 0.
            do 80 l = 1, nn
              a(ll,l) = a(ll,l) - a(icol,l) * dum
   80       continue 
            do 90 l = 1, m
              b(ll,l) = b(ll,l) - b(icol,l) * dum
   90       continue 
          end if 
  100   continue 
  110 continue 
C End of the main loop over columns of the reduction. 
C It only remains to unscramble the solution in view of the column
C interchanges. We do this by interchanging pairs of columns in the
C reverse order that the permutation was built up.
      do 130 l = nn, 1, -1
        if (indxr(l) .ne. indxc(l)) then 
          do 120 k = 1, nn
            dum = a(k,indxr(l))
            a(k,indxr(l)) = a(k,indxc(l))
            a(k,indxc(l)) = dum
  120     continue 
        end if 
  130 continue 
C
C End of inversion procedure.
      return
      end

C Following are two subroutines for finding the eigenvalues of a real
C symmetric matrix using the Householder method, a procedure recommended
C by Numerical Recipes (Press et al., 1986): routines TRED2 and TQLI.

      Subroutine TRED2(A,N,NP,D,E)
C
C Householder reduction of a real, symmetric, N by N matrix A, stored in
C an NP by NP physical array.  On output, A is replaced by the orthogonal
C matrix Q effecting the transformation.  D returns the diagonal elements
C of the tridiagonal matrix, and E the off-diagonal elements, with E(1) = 0.
C Several statements, as noted in comments, can be omitted if only
C eigenvalues are to be found, in which case A contains no useful information
C on output.  Otherwise they are to be included.
C
      Dimension A(NP,NP), D(NP), E(NP)
C REAL*8 statement added for double precision.
      Real*8 A,D,E,H,SCALE,F,G,HH
      
      IF (N.GT.1) THEN
         DO 18 I = N,2,-1
              L = I - 1
              H = 0.
              SCALE = 0.
              IF (L.GT.1) THEN
                 DO 11 K = 1,L
                    SCALE = SCALE + DABS(A(I,K))
11                  CONTINUE
              IF (SCALE.EQ.0) THEN
                 E(I) = A(I,L)
              ELSE
                 DO 12 K = 1,L
                    A(I,K) = A(I,K)/SCALE
                    H = H + A(I,K)**2
12               CONTINUE
                 F = A(I,L)
                 G = -SIGN(DSQRT(H),F)
                 E(I) = SCALE*G
                 H = H-F*G
                 A(I,L) = F-G
                 F = 0.
                 DO 15 J = 1,L
C Omit following line if finding only eigenvalues.
                    A(J,I) = A(I,J)/H
                    G = 0.
                    DO 13 K = 1,J
                       G = G + A(J,K) * A(I,K)
13                  CONTINUE
                    IF (L.GT.J) THEN
                       DO 14 K = J+1, L
                          G = G + A(K,J)*A(I,K)
14                     CONTINUE
                    END IF
                    E(J) = G/H
                    F = F + E(J)*A(I,J)
15                  CONTINUE
                 HH = F/(H + H)
                 DO 17 J = 1,L
                    F = A(I,J)
                    G = E(J) - HH*F
                    E(J) = G
                    DO 16 K = 1,J
                       A(J,K) = A(J,K) - F*E(K) - G*A(I,K)
16                  CONTINUE
17               CONTINUE
              END IF
              ELSE
                 E(I) = A(I,L)
              END IF
              D(I) = H
18       CONTINUE
      END IF
C Omit following line if finding only eigenvalues.
      D(1) = 0.
      E(1) = 0.
      DO 23 I = 1,N
C Delete lines from here...
         L = I-1
         IF (D(I).NE.0.) THEN
            DO 21 J = 1,L
               G = 0.
               DO 19 K = 1,L
                  G = G + A(I,K) * A(K,J)
19             CONTINUE
               DO 20 K = 1,L
                  A(K,J) = A(K,J) - G*A(K,I)
20             CONTINUE
21          CONTINUE
         END IF
C ... to here when finding only eigenvalues.
         D(I) = A(I,I)
C Also delete lines from here ....
         A(I,I) = 1.
         IF(L.GE.1) THEN
            DO 22 J = 1,L
               A(I,J) = 0.
               A(J,I) = 0.
22          CONTINUE
         END IF
C ... to here when finding only eigenvalues.
23    continue
      return
      end

      Subroutine TQLI (D,E,N,NP,Z)
C
C QL algorithm with implicit shifts, to determine the eigenvalues and
C eigenvectors of a real, symmetric, tridiagonal matrix previously
C reduced by TRED 2 (Numerical Recipes).  D is a vector of length NP.
C On input, its first N elements are the diagonal elements of the tridiagonal
C matrix.  On output, it returns the eigenvalues.  The vector E inputs the
C subdiagonal elements of the tridiagonal matrix, with E(1) arbitrary.  On
C output, E is destroyed.  When finding only the eigenvalues, several lines
C may be omitted, as noted in the coments.  If the eigenvectors of the
C tridiagonal matrix are desired, the matrix Z (N by N matrix stored in
C NP by NP array) is input as the identity matrix.  If the eigenvectors of
C a matrix that has been reduced by TRED2 are required, then Z is input as
C the matrix output by TRED2.  In either case, the Kth column of Z returns
C the normalized eigenvector corresponding to D(K).
C
      Dimension D(NP), E(NP), Z(NP,NP)
C REAL*8 statement added to original code for double precision.
      Real*8 D,E,Z,DD,G,R,S,C,P,F,B

      IF (N.GT.1) THEN
         DO 11 I = 2,N
            E(I-1) = E(I)
11       CONTINUE
         E(N) = 0.
         DO 15 L = 1,N
            ITER = 0
1           DO 12 M = L, N-1
               DD = DABS(D(M)) + DABS(D(M+1))
               IF (DABS(E(M)) + DD.EQ.DD) GO TO 2
12          CONTINUE
            M = N
2           IF (M.NE.L) THEN
               IF (ITER.EQ.50) Stop 'Too many iterations in TQLI'
               ITER = ITER + 1
               G = (D(L+1)-D(L))/(2.*E(L))
               R = SQRT(G**2+1.)
               G = D(M) - D(L) + E(L)/(G + SIGN(R,G))
               S = 1.
               C = 1.
               P = 0.
               DO 14 I = M-1,L,-1
                  F = S*E(I)
                  B = C*E(I)
                  IF (DABS(F).GE.DABS(G)) THEN
                     C = G/F
                     R = DSQRT(C**2+1.)
                     E(I+1) = F*R
                     S = 1./R
                     C = C*S
                  ELSE
                     S = F/G
                     R = DSQRT(S**2+1.)
                     E(I+1) = G*R
                     C = 1./R
                     S = S*C
                  END IF
                  G = D(I+1) - P
                  R = (D(I) - G)*S+2.*C*B
                  P = S*R
                  D(I+1) = G + P
                  G = C*R - B
C Omit lines from here ...
                  DO 13 K = 1,N
                     F = Z(K,I+1)
                     Z(K,I+1) = S*Z(K,I) + C*F
                     Z(K,I) = C*Z(K,I) - S*F
13                CONTINUE
C ... to here when finding only eigenvalues.
14             CONTINUE
               D(L) = D(L) - P
               E(L) = G
               E(M) = 0.
               GO TO 1
            END IF
15          CONTINUE
      end if
      return
      end
      
      Subroutine SVDcmp(r,c,A,V,W,rv1,nmax)
      Integer r,c
      Integer i,its,j,jj,k,L,nm
      Real*8 A(nmax,nmax),V(nmax,nmax),W(nmax),rv1(nmax)
      Real*8 anorm,cc,f,g,h,s,scale,x,y,z,Pythag
C
C Singular value decomposition (SVD). From 'Numerical Recipes' (Press et al. 1986).
C
C Given a matrix A(1:r,1:c), with physical dimensions mp by np, this
C routine computes its singular value decomposition, A = Uhat.W.V^t.  The
C matrix Uhat replaces A on output.  The diagonal matrix of singular values
C W is output as a vector w(1:c).  The matrix V (not the transpose V^t)
C is output as V(1:c,1:c). 'r' must be greater or equal to 'c'; if it is
C smaller, then A should be filled up to square with zero rows.
C
      if(r.lt.c) then
         do 4 i=r+1,c
         do 4 j=1,c
    4    A(i,j)=0.0
         endif
C
C      WRITE (6,*) 'These are the values input as matrix A:'
C      Do 5 i=1,r
C    5 WRITE (6,*) (a(i,j), j=1,c)
C
C Householder reduction to bidiagonal form
      g=0.0
      scale=0.0
      anorm=0.0
      do 25 i =1,c
           L=i+1
           rv1(i)=scale*g
           g=0.0
           s=0.0
           scale=0.0
           if(i.le.r) then
                do 11 k=i,r
                     scale=scale+abs(a(k,i))
11              continue
                if(scale.ne.0.0) then
                     do 12 k=i,r
                          a(k,i)=a(k,i)/scale
                          s=s+a(k,i)*a(k,i)
12                   continue
                     f=a(i,i)
                     g=-sign(sqrt(s),f)
                     h=f*g-s
                     a(i,i)=f-g
                     if(i.ne.c) then
                     do 15 j=L,c
                          s=0.0
                          do 13 k=i,r
                          s=s+a(k,i)*a(k,j)
13                        continue
                          f=s/h
                          do 14 k=i,r
                               a(k,j)=a(k,j)+f*a(k,i)
14                        continue
15                   continue
                     endif
                     do 16 k=i,r
                          a(k,i)=scale*a(k,i)
16                   continue
                endif
           endif
           w(i)=scale*g
           g=0.0
           s=0.0
           scale=0.0
           if((i.le.r).and.(i.ne.c)) then
                do 17 k=L,c
                     scale=scale+abs(a(i,k))
17              continue
                if(scale.ne.0.0) then
                     do 18 k=L,c
                          a(i,k)=a(i,k)/scale
                          s=s+a(i,k)*a(i,k)
18                   continue
                     f=a(i,L)
                     g=-sign(sqrt(s),f)
                     h=f*g-s
                     a(i,L)=f-g
                     do 19 k=L,c
                          rv1(k)=a(i,k)/h
19                   continue
                     if(i.ne.r) then
                     do 23 j=L,r
                          s=0.0
                          do 21 k=L,c
                               s=s+a(j,k)*a(i,k)
21                        continue
                          do 22 k=L,c
                               a(j,k)=a(j,k)+s*rv1(k)
22                        continue
23                   continue
                     endif
                     do 24 k=L,c
                          a(i,k)=scale*a(i,k)
24                   continue
                endif
           endif
           anorm=max(anorm,(abs(w(i))+abs(rv1(i))))
25    continue
C Accumulation of right-hand transformations
      do 32 i=c,1,-1
           if(i.lt.c) then
                if(g.ne.0.0) then
                     do 26 j=L,c
                          v(j,i)=(a(i,j)/a(i,L))/g
26                   continue
                     do 29 j=L,c
                          s=0.0
                          do 27 k=L,c
                               s=s+a(i,k)*v(k,j)
27                        continue
                          do 28 k=L,c
                               v(k,j)=v(k,j)+s*v(k,i)
28                        continue
29                   continue
                endif
                do 31 j=L,c
                     v(i,j)=0.0
                     v(j,i)=0.0
31              continue
           endif
           v(i,i)=1.0
           g=rv1(i)
           L=i
32    continue
C Accumulation of left-hand transformations
      do 39 i=min(r,c),1,-1
           L=i+1
           g=w(i)
           if(i.lt.c) then
           do 33 j=L,c
                a(i,j)=0.0
33         continue
           endif
           if(g.ne.0.0) then
                g=1.0/g
           if(i.ne.c) then
                do 36 j=L,c
                     s=0.0
                     do 34 k=L,r
                          s=s+a(k,i)*a(k,j)
34                   continue
                     f=(s/a(i,i))*g
                     do 35 k=i,r
                          a(k,j)=a(k,j)+f*a(k,i)
35                   continue
36              continue
           endif
                do 37 j=i,r
                     a(j,i)=a(j,i)*g
37              continue
           else
                do 38 j=i,r
                     a(j,i)=0.0
38              continue
           endif
           a(i,i)=a(i,i)+1.0
39    continue
C Diagonalization of the bidiagonal form
      do 49 k=c,1,-1
           do 48 its=1,30
                do 41 L=k,1,-1
                     nm=L-1
                     if((abs(rv1(L))+anorm).eq.anorm) goto 2
                     if((abs(w(nm))+anorm).eq.anorm) goto 1
41              continue
1               cc=0.0
                s=1.0
                do 43 i=L,k
                     f=s*rv1(i)
                     rv1(i)=cc*rv1(i)
                     if((abs(f)+anorm).eq.anorm) goto 2
                     g=w(i)
                     h=Pythag(f,g)
                     w(i)=h
                     h=1.0/h
                     cc= (g*h)
                     s=-(f*h)
                     do 42 j=1,r
                          y=a(j,nm)
                          z=a(j,i)
                          a(j,nm)=(y*cc)+(z*s)
                          a(j,i)=-(y*s)+(z*cc)
42                   continue
43              continue
2               z=w(k)
                if(L.eq.k) then
                     if(z.lt.0.0) then
                          w(k)=-z
                          do 44 j=1,c
                               v(j,k)=-v(j,k)
44                        continue
                     endif
                     goto 3
                endif
                if(its.eq.30) pause 'No convergence in svdcmp'
                x=w(L)
                nm=k-1
                y=w(nm)
                g=rv1(nm)
                h=rv1(k)
                f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
                g=Pythag(f,1.0)
                f=((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
                cc=1.0
                s=1.0
                do 47 j=L,nm
                     i=j+1
                     g=rv1(i)
                     y=w(i)
                     h=s*g
                     g=cc*g
                     z=Pythag(f,h)
                     rv1(j)=z
                     cc=f/z
                     s=h/z
                     f= (x*cc)+(g*s)
                     g=-(x*s)+(g*cc)
                     h=y*s
                     y=y*cc
                     do 45 jj=1,c
                          x=v(jj,j)
                          z=v(jj,i)
                          v(jj,j)= (x*cc)+(z*s)
                          v(jj,i)=-(x*s)+(z*cc)
45                   continue
                     z=Pythag(f,h)
                     w(j)=z
                     if(z.ne.0.0) then
                          z=1.0/z
                          cc=f*z
                          s=h*z
                     endif
                     f= (cc*g)+(s*y)
                     x=-(s*g)+(cc*y)
                     do 46 jj=1,r
                          y=a(jj,j)
                          z=a(jj,i)
                          a(jj,j)= (y*cc)+(z*s)
                          a(jj,i)=-(y*s)+(z*cc)
46                   continue
47              continue
                rv1(L)=0.0
                rv1(k)=f
                w(k)=x
48         continue
3          continue
49    continue
      return
      end
      
      Function Pythag(a,b)
      Real*8 a,b,pythag
      Real*8 absa,absb
C Computes sqrt(a^2 + b^2) without destructive underflow or overflow
C From 'Numerical Recipes' (Press et al., 1986).
      absa=abs(a)
      absb=abs(b)
      if(absa.gt.absb)then
           pythag=absa*sqrt(1.+(absb/absa)**2)
      else
           if(absb.eq.0.)then
                pythag=0.
           else
                pythag=absb*sqrt(1.+(absa/absb)**2)
           endif
      endif
      return
      end
